Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::MultiReader Class Reference

An IndexReader which reads multiple indexes, appending their content. More...

`#include <MultiReader.h>`

Inheritance diagram for Lucene::MultiReader:

## Public Member Functions

| MultiReader (Collection< IndexReaderPtr > subReaders, bool closeSubReaders=true)
| Construct a MultiReader aggregating the named set of (sub)readers. Directory locking for delete, undeleteAll, and setNorm operations is left to the subreaders. More...
virtual | ~MultiReader ()
virtual String | getClassName ()
boost::shared_ptr< MultiReader > | shared_from_this ()
virtual IndexReaderPtr | reopen ()
| Tries to reopen the subreaders. More...
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Clones the subreaders. (see IndexReader#clone()). More...
virtual Collection < TermFreqVectorPtr > | getTermFreqVectors (int32_t docNumber)

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored. More...

virtual TermFreqVectorPtr | getTermFreqVector (int32_t docNumber, const String &field)
| Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned. More...
virtual void | getTermFreqVector (int32_t docNumber, const String &field, TermVectorMapperPtr mapper)
| Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector. More...
virtual void | getTermFreqVector (int32_t docNumber, TermVectorMapperPtr mapper)
| Map all the term vectors for all fields in a Document. More...
virtual bool | isOptimized ()
| Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class. More...
virtual int32_t | numDocs ()
| Returns the number of documents in this index. More...
virtual int32_t | maxDoc ()
| Returns one greater than the largest possible document number. More...
virtual DocumentPtr | document (int32_t n, FieldSelectorPtr fieldSelector)
| Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. More...
virtual bool | isDeleted (int32_t n)
| Returns true if document n has been deleted. More...
virtual bool | hasDeletions ()
| Returns true if any documents have been deleted. More...
virtual bool | hasNorms (const String &field)
| Returns true if there are norms stored for this field. More...
virtual ByteArray | norms (const String &field)
| Returns the byte-encoded normalization factor for the named field of every document. More...
virtual void | norms (const String &field, ByteArray norms, int32_t offset)
| Reads the byte-encoded normalization factor for the named field of every document. More...
virtual TermEnumPtr | terms ()
| Returns an enumeration of all the terms in the index. More...
virtual TermEnumPtr | terms (TermPtr t)
| Returns an enumeration of all terms starting at a given term. More...
virtual int32_t | docFreq (TermPtr t)
| Returns the number of documents containing the term t. More...
virtual TermDocsPtr | termDocs ()
| Returns an unpositioned TermDocs enumerator. More...
virtual TermPositionsPtr | termPositions ()
| Returns an unpositioned TermPositions enumerator. More...
virtual HashSet< String > | getFieldNames (FieldOption fieldOption)
| Get a list of unique field names that exist in this index and have the specified field option information. More...
virtual bool | isCurrent ()
| Checks recursively if all subreaders are up to date. More...
virtual int64_t | getVersion ()
| Not implemented. More...
virtual Collection < IndexReaderPtr > | getSequentialSubReaders ()
| Returns the sequential sub readers that this reader is logically composed of. More...
Public Member Functions inherited from Lucene::IndexReader
| IndexReader ()
virtual | ~IndexReader ()
boost::shared_ptr< IndexReader > | shared_from_this ()
int32_t | getRefCount ()
| Returns the current refCount for this reader. More...
void | incRef ()

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding decRef, in a finally clause; otherwise the reader may never be closed. Note that close simply calls decRef(), which means that the IndexReader will not really be closed until decRef has been called for all outstanding references. More...

void | decRef ()
| Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed. More...
virtual IndexReaderPtr | reopen (bool openReadOnly)
| Just like reopen(), except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned. More...
virtual IndexReaderPtr | reopen (IndexCommitPtr commit)
| Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned. More...
virtual LuceneObjectPtr | clone (bool openReadOnly, LuceneObjectPtr other=LuceneObjectPtr())
| Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader. More...
virtual DirectoryPtr | directory ()
| Returns the directory associated with this index. The default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperation exception if one was not specified. More...
virtual MapStringString | getCommitUserData ()
| Retrieve the String userData optionally passed to IndexWriter::commit. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
int32_t | numDeletedDocs ()
| Returns the number of deleted documents. More...
virtual DocumentPtr | document (int32_t n)
| Returns the stored fields of the n'th Document in this index. More...
virtual bool | hasChanges ()
| Used for testing. More...
virtual void | setNorm (int32_t doc, const String &field, uint8_t value)
| Resets the normalization factor for the named field of the named document. The norm represents the product of the field's boost and its length normalization. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old. More...
virtual void | setNorm (int32_t doc, const String &field, double value)
| Resets the normalization factor for the named field of the named document. More...
virtual TermDocsPtr | termDocs (TermPtr term)
| Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...
virtual TermPositionsPtr | termPositions (TermPtr term)

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...

virtual void | deleteDocument (int32_t docNum)
| Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the document method will result in an error. The presence of this document may still be reflected in the docFreq statistic, though this will be corrected eventually as the index is further modified. More...
virtual int32_t | deleteDocuments (TermPtr term)
| Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See deleteDocument(int) for information about when this deletion will become effective. More...
virtual void | undeleteAll ()
| Undeletes all documents currently marked as deleted in this index. More...
void | flush ()
void | flush (MapStringString commitUserData)
void | commit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
void | close ()
| Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called. More...
virtual IndexCommitPtr | getIndexCommit ()
| Return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file. More...
virtual LuceneObjectPtr | getFieldCacheKey ()
virtual LuceneObjectPtr | getDeletesCacheKey ()
| This returns null if the reader has no deletions. More...
virtual int64_t | getUniqueTermCount ()
| Returns the number of unique terms (across all fields) in this reader. More...
virtual int32_t | getTermInfosIndexDivisor ()
| For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::IndexReader
static String | _getClassName ()
static IndexReaderPtr | open (DirectoryPtr directory)
| Returns a IndexReader reading the index in the given Directory, with readOnly = true. More...
static IndexReaderPtr | open (DirectoryPtr directory, bool readOnly)
| Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (IndexCommitPtr commit, bool readOnly)
| Returns an IndexReader reading the index in the given IndexCommit. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (DirectoryPtr directory, IndexDeletionPolicyPtr deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (DirectoryPtr directory, IndexDeletionPolicyPtr deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (IndexCommitPtr commit, IndexDeletionPolicyPtr deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (IndexCommitPtr commit, IndexDeletionPolicyPtr deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static int64_t | lastModified (DirectoryPtr directory2)
| Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use isCurrent() instead. More...
static int64_t | getCurrentVersion (DirectoryPtr directory)
| Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index. More...
static MapStringString | getCommitUserData (DirectoryPtr directory)
| Reads commitUserData, previously passed to IndexWriter#commit(MapStringString), from current index segments file. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
static bool | indexExists (DirectoryPtr directory)
| Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it. More...
static void | main (Collection< String > args)
| Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored. More...
static Collection< IndexCommitPtr > | listCommits (DirectoryPtr dir)

Returns all commit points that exist in the Directory. Normally, because the default is KeepOnlyLastCommitDeletionPolicy, there would be only one commit point. But if you're using a custom IndexDeletionPolicy then there could be many commits. Once you have a given commit, you can open a reader on it by calling IndexReader#open(IndexCommit,bool). There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array. More...

## Protected Member Functions

IndexReaderPtr | doReopen (bool doClone)
| If clone is true then we clone each of the subreaders. More...
virtual void | doDelete (int32_t docNum)
| Implements deletion of the document numbered docNum. More...
virtual void | doUndeleteAll ()
| Implements actual undeleteAll() in subclass. More...
int32_t | readerIndex (int32_t n)
| Find reader for doc n. More...
virtual void | doSetNorm (int32_t doc, const String &field, uint8_t value)
| Implements setNorm in subclass. More...
virtual void | doCommit (MapStringString commitUserData)
| Implements commit. More...
virtual void | doClose ()
| Implements close. More...
Protected Member Functions inherited from Lucene::IndexReader
void | ensureOpen ()
virtual void | acquireWriteLock ()
| Does nothing by default. Subclasses that require a write lock for index modifications must implement this method. More...
void | commit ()
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

Collection< IndexReaderPtr > | subReaders
Collection< int32_t > | starts
Collection< uint8_t > | decrefOnClose
MapStringByteArray | normsCache
int32_t | _maxDoc
int32_t | _numDocs
bool | _hasDeletions
Protected Attributes inherited from Lucene::IndexReader
bool | closed
bool | _hasChanges
int32_t | refCount

## Additional Inherited Members

Public Types inherited from Lucene::IndexReader
enum | FieldOption { FIELD_OPTION_ALL, FIELD_OPTION_INDEXED, FIELD_OPTION_STORES_PAYLOADS, FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS, FIELD_OPTION_UNINDEXED, FIELD_OPTION_INDEXED_WITH_TERMVECTOR, FIELD_OPTION_INDEXED_NO_TERMVECTOR, FIELD_OPTION_TERMVECTOR, FIELD_OPTION_TERMVECTOR_WITH_POSITION, FIELD_OPTION_TERMVECTOR_WITH_OFFSET, FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET }
| Constants describing field properties, for example used for IndexReader#getFieldNames(FieldOption). More...
Static Public Attributes inherited from Lucene::IndexReader
static const int32_t | DEFAULT_TERMS_INDEX_DIVISOR
Static Protected Member Functions inherited from Lucene::IndexReader
static IndexReaderPtr | open (DirectoryPtr directory, IndexDeletionPolicyPtr deletionPolicy, IndexCommitPtr commit, bool readOnly, int32_t termInfosIndexDivisor)

## Detailed Description

An IndexReader which reads multiple indexes, appending their content.

## Constructor & Destructor Documentation

Lucene::MultiReader::MultiReader | ( | Collection< IndexReaderPtr > | subReaders,
|  | bool | closeSubReaders = `true`
| ) |  |

Construct a MultiReader aggregating the named set of (sub)readers. Directory locking for delete, undeleteAll, and setNorm operations is left to the subreaders.

Parameters

  closeSubReaders | indicates whether the subreaders should be closed when this MultiReader is closed
  subReaders | set of (sub)readers

virtual Lucene::MultiReader::~MultiReader | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::MultiReader::_getClassName | ( | ) |  |

inline static

virtual LuceneObjectPtr Lucene::MultiReader::clone | ( | LuceneObjectPtr | other = `LuceneObjectPtr()`) |  |

virtual

Clones the subreaders. (see IndexReader#clone()).

If subreaders are shared, then the reference count of those readers is increased to ensure that the subreaders remain open until the last referring reader is closed.

Reimplemented from Lucene::IndexReader.

virtual int32_t Lucene::MultiReader::docFreq | ( | TermPtr | t) |  |

virtual

Returns the number of documents containing the term t.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::doClose | ( | ) |  |

protected virtual

Implements close.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::doCommit | ( | MapStringString | commitUserData) |  |

protected virtual

Implements commit.

Implements Lucene::IndexReader.

virtual DocumentPtr Lucene::MultiReader::document | ( | int32_t | n,
|  | FieldSelectorPtr | fieldSelector
| ) |  |

virtual

Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::doDelete | ( | int32_t | docNum) |  |

protected virtual

Implements deletion of the document numbered docNum.

Implements Lucene::IndexReader.

IndexReaderPtr Lucene::MultiReader::doReopen | ( | bool | doClone) |  |

protected

If clone is true then we clone each of the subreaders.

Parameters

  doClone |

Returns
  New IndexReader, or same one (this) if reopen/clone is not necessary

virtual void Lucene::MultiReader::doSetNorm | ( | int32_t | doc,
|  | const String & | field,
|  | uint8_t | value
| ) |  |

protected virtual

Implements setNorm in subclass.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::doUndeleteAll | ( | ) |  |

protected virtual

Implements actual undeleteAll() in subclass.

Implements Lucene::IndexReader.

virtual String Lucene::MultiReader::getClassName | ( | ) |  |

inline virtual

Reimplemented from Lucene::IndexReader.

virtual HashSet<String> Lucene::MultiReader::getFieldNames | ( | FieldOption | fieldOption) |  |

virtual

Get a list of unique field names that exist in this index and have the specified field option information.

Implements Lucene::IndexReader.

virtual Collection<IndexReaderPtr> Lucene::MultiReader::getSequentialSubReaders | ( | ) |  |

virtual

Returns the sequential sub readers that this reader is logically composed of.

Reimplemented from Lucene::IndexReader.

virtual TermFreqVectorPtr Lucene::MultiReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field
| ) |  |

virtual

Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned.

Parameters

  docNumber | document for which the term frequency vector is returned.
  field | field for which the term frequency vector is returned.

Returns
  term frequency vector May be null if field does not exist in the specified document or term vector was not stored.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field,
|  | TermVectorMapperPtr | mapper
| ) |  |

virtual

Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector.

Parameters

  docNumber | The number of the document to load the vector for
  field | The name of the field to load
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::getTermFreqVector | ( | int32_t | docNumber,
|  | TermVectorMapperPtr | mapper
| ) |  |

virtual

Map all the term vectors for all fields in a Document.

Parameters

  docNumber | The number of the document to load the vector for
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implements Lucene::IndexReader.

virtual Collection<TermFreqVectorPtr> Lucene::MultiReader::getTermFreqVectors | ( | int32_t | docNumber) |  |

virtual

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored.

Parameters

  docNumber | document for which term frequency vectors are returned

Returns
  array of term frequency vectors. May be null if no term vectors have been stored for the specified document.

Implements Lucene::IndexReader.

virtual int64_t Lucene::MultiReader::getVersion | ( | ) |  |

virtual

Not implemented.

Reimplemented from Lucene::IndexReader.

virtual bool Lucene::MultiReader::hasDeletions | ( | ) |  |

virtual

Returns true if any documents have been deleted.

Implements Lucene::IndexReader.

virtual bool Lucene::MultiReader::hasNorms | ( | const String & | field) |  |

virtual

Returns true if there are norms stored for this field.

Reimplemented from Lucene::IndexReader.

virtual bool Lucene::MultiReader::isCurrent | ( | ) |  |

virtual

Checks recursively if all subreaders are up to date.

Reimplemented from Lucene::IndexReader.

virtual bool Lucene::MultiReader::isDeleted | ( | int32_t | n) |  |

virtual

Returns true if document n has been deleted.

Implements Lucene::IndexReader.

virtual bool Lucene::MultiReader::isOptimized | ( | ) |  |

virtual

Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.

Returns
  true if the index is optimized; false otherwise

Reimplemented from Lucene::IndexReader.

virtual int32_t Lucene::MultiReader::maxDoc | ( | ) |  |

virtual

Returns one greater than the largest possible document number.

Implements Lucene::IndexReader.

virtual ByteArray Lucene::MultiReader::norms | ( | const String & | field) |  |

virtual

Returns the byte-encoded normalization factor for the named field of every document.

Implements Lucene::IndexReader.

virtual void Lucene::MultiReader::norms | ( | const String & | field,
|  | ByteArray | norms,
|  | int32_t | offset
| ) |  |

virtual

Reads the byte-encoded normalization factor for the named field of every document.

Implements Lucene::IndexReader.

virtual int32_t Lucene::MultiReader::numDocs | ( | ) |  |

virtual

Returns the number of documents in this index.

Implements Lucene::IndexReader.

int32_t Lucene::MultiReader::readerIndex | ( | int32_t | n) |  |

protected

Find reader for doc n.

virtual IndexReaderPtr Lucene::MultiReader::reopen | ( | ) |  |

virtual

Tries to reopen the subreaders.

If one or more subreaders could be re-opened (ie. subReader.reopen() returned a new instance != subReader), then a new MultiReader instance is returned, otherwise this instance is returned.

A re-opened instance might share one or more subreaders with the old instance. Index modification operations result in undefined behavior when performed before the old instance is closed. (see IndexReader#reopen()).

If subreaders are shared, then the reference count of those readers is increased to ensure that the subreaders remain open until the last referring reader is closed.

Reimplemented from Lucene::IndexReader.

boost::shared_ptr< MultiReader > Lucene::MultiReader::shared_from_this | ( | ) |  |

inline

virtual TermDocsPtr Lucene::MultiReader::termDocs | ( | ) |  |

virtual

Returns an unpositioned TermDocs enumerator.

Implements Lucene::IndexReader.

virtual TermPositionsPtr Lucene::MultiReader::termPositions | ( | ) |  |

virtual

Returns an unpositioned TermPositions enumerator.

Implements Lucene::IndexReader.

virtual TermEnumPtr Lucene::MultiReader::terms | ( | ) |  |

virtual

Returns an enumeration of all the terms in the index.

Implements Lucene::IndexReader.

virtual TermEnumPtr Lucene::MultiReader::terms | ( | TermPtr | t) |  |

virtual

Returns an enumeration of all terms starting at a given term.

Implements Lucene::IndexReader.

## Field Documentation

bool Lucene::MultiReader::_hasDeletions

protected

int32_t Lucene::MultiReader::_maxDoc

protected

int32_t Lucene::MultiReader::_numDocs

protected

Collection<uint8_t> Lucene::MultiReader::decrefOnClose

protected

MapStringByteArray Lucene::MultiReader::normsCache

protected

Collection<int32_t> Lucene::MultiReader::starts

protected

Collection<IndexReaderPtr> Lucene::MultiReader::subReaders

protected

The documentation for this class was generated from the following file:

- MultiReader.h

clucene.sourceforge.net